Index: /trunk/ArchTOIPipe/SMakefile
===================================================================
--- /trunk/ArchTOIPipe/SMakefile	(revision 1528)
+++ /trunk/ArchTOIPipe/SMakefile	(revision 1529)
@@ -16,7 +16,9 @@
 EXEOLIST := $(AOBJ)fits2asc.o $(AOBJ)tsttoi.o $(AOBJ)tsttoi2.o $(AOBJ)simtst.o \
             $(AOBJ)tstrztoi.o $(AOBJ)rztoi.o $(AOBJ)sfftc.o $(AOBJ)mesovh.o \
-            $(AOBJ)fits2ascii.o $(AOBJ)tgenw.o $(AOBJ)tstmap2toi.o $(AOBJ)tsttoi2map.o 
+            $(AOBJ)fits2ascii.o $(AOBJ)tgenw.o $(AOBJ)tstmap2toi.o $(AOBJ)tsttoi2map.o \
+            $(AOBJ)tstflag.o
 EXELIST := $(AOBJ)sfftc $(AOBJ)simtst $(AOBJ)mesovh $(AOBJ)tstrztoi $(AOBJ)fits2asc $(AOBJ)tsttoi \
-           $(AOBJ)tsttoi2 $(AOBJ)fits2ascii $(AOBJ)tgenw $(AOBJ)tstmap2toi $(AOBJ)tsttoi2map
+           $(AOBJ)tsttoi2 $(AOBJ)fits2ascii $(AOBJ)tgenw $(AOBJ)tstmap2toi $(AOBJ)tsttoi2map \
+           $(AOBJ)tstflag
 
 INCLIST := asciitoiwtr.h fitstoirdr.h fitstoiwtr.h toi.h config.h conf.h \
@@ -34,32 +36,74 @@
 LIBF =  $(SLB)libsophya.so $(SLB)libextsophya.so 
 LIBS =  -L$(SLB) -lextsophya -lsophya -lpthread -lm
-ifeq ($(MACHEROS),OSF1)
-LIBS := $(LIBS) -lfor
-endif
+####ifeq ($(MACHEROS),OSF1)
+####LIBS := $(LIBS) -lfor
+####endif
 
-
+########################################
+#### Les Executables des Programmes ####
+########################################
+tstrztoi: $(AOBJ)tstrztoi
+	@echo done
 $(AOBJ)tstrztoi: $(AOBJ)tstrztoi.o $(AOBJ)rztoi.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+sfftc: $(AOBJ)sfftc
+	@echo done
 $(AOBJ)sfftc: $(AOBJ)sfftc.o  $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+mesovh: $(AOBJ)mesovh
+	@echo done
 $(AOBJ)mesovh: $(AOBJ)mesovh.o  $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+simtst: $(AOBJ)simtst
+	@echo done
 $(AOBJ)simtst: $(AOBJ)simtst.o  $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+fits2asc: $(AOBJ)fits2asc
+	@echo done
 $(AOBJ)fits2asc: $(AOBJ)fits2asc.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+tsttoi: $(AOBJ)tsttoi
+	@echo done
 $(AOBJ)tsttoi: $(AOBJ)tsttoi.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+tsttoi2: $(AOBJ)tsttoi2
+	@echo done
 $(AOBJ)tsttoi2: $(AOBJ)tsttoi2.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+fits2ascii: $(AOBJ)fits2ascii
+	@echo done
 $(AOBJ)fits2ascii: $(AOBJ)fits2ascii.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+tgenw: $(AOBJ)tgenw
+	@echo done
 $(AOBJ)tgenw: $(AOBJ)tgenw.o  $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+tstmap2toi: $(AOBJ)tstmap2toi
+	@echo done
 $(AOBJ)tstmap2toi: $(AOBJ)tstmap2toi.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+tsttoi2map: $(AOBJ)tsttoi2map
+	@echo done
 $(AOBJ)tsttoi2map: $(AOBJ)tsttoi2map.o $(LIBOLIST)
 	$(LINK.cc)  -o $@ $^ $(LIBS)
 
+tstflag: $(AOBJ)tstflag
+	@echo done
+$(AOBJ)tstflag: $(AOBJ)tstflag.o $(LIBOLIST)
+	$(LINK.cc)  -o $@ $^ $(LIBS)
+
+################################################
+#### Compilation des Sources des Programmes ####
+################################################
 $(AOBJ)simtst.o: simtst.cc $(INCLIST)
 $(AOBJ)sfftc.o: sfftc.cc $(INCLIST)
@@ -74,22 +118,21 @@
 $(AOBJ)tstmap2toi.o: tstmap2toi.cc $(INCLIST)
 $(AOBJ)tsttoi2map.o: tsttoi2map.cc $(INCLIST)
+$(AOBJ)tstflag.o: tstflag.cc $(INCLIST)
 
-$(AOBJ)asciitoiwtr.o: asciitoiwtr.cc asciitoiwtr.h toi.h config.h conf.h \
-                      toiprocessor.h toimanager.h 
+
+################################################
+#### Compilation des Sources des Librairies ####
+################################################
+$(AOBJ)asciitoiwtr.o: asciitoiwtr.cc asciitoiwtr.h toi.h config.h conf.h toiprocessor.h toimanager.h 
 $(AOBJ)fitstoirdr.o: fitstoirdr.cc fitstoirdr.h toiprocessor.h config.h conf.h
 $(AOBJ)fitstoiwtr.o: fitstoiwtr.cc fitstoiwtr.h toi.h config.h conf.h
 $(AOBJ)toi.o: toi.cc toiprocessor.h config.h conf.h toi.h 
 $(AOBJ)toimanager.o: toimanager.cc toimanager.h
-$(AOBJ)toiprocessor.o: toiprocessor.cc toiprocessor.h config.h conf.h toi.h \
-                       toimanager.h
+$(AOBJ)toiprocessor.o: toiprocessor.cc toiprocessor.h config.h conf.h toi.h toimanager.h
 $(AOBJ)genwproc.o: genwproc.h toiprocessor.h toimanager.h
-$(AOBJ)toisqfilter.o: toisqfilter.cc toisqfilter.h toiprocessor.h config.h \
-                      conf.h toi.h toimanager.h
-$(AOBJ)toiseqbuff.o: toiseqbuff.cc toiprocessor.h config.h conf.h toi.h \
-                     toiseqbuff.h 
-$(AOBJ)toiregwindow.o: toiregwindow.cc toiprocessor.h config.h conf.h toi.h \
-                     toiregwindow.h 
-$(AOBJ)simtoipr.o: simtoipr.cc toiprocessor.h config.h conf.h toi.h \
-                   simtoipr.h 
+$(AOBJ)toisqfilter.o: toisqfilter.cc toisqfilter.h toiprocessor.h config.h conf.h toi.h toimanager.h
+$(AOBJ)toiseqbuff.o: toiseqbuff.cc toiprocessor.h config.h conf.h toi.h toiseqbuff.h 
+$(AOBJ)toiregwindow.o: toiregwindow.cc toiprocessor.h config.h conf.h toi.h toiregwindow.h 
+$(AOBJ)simtoipr.o: simtoipr.cc toiprocessor.h config.h conf.h toi.h simtoipr.h 
 $(AOBJ)map2toi.o: map2toi.cc map2toi.h 
 $(AOBJ)toi2map.o: toi2map.cc toi2map.h 