Index: /trunk/SophyaPI/PI/pibwdggen.cc
===================================================================
--- /trunk/SophyaPI/PI/pibwdggen.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/pibwdggen.cc	(revision 1534)
@@ -288,8 +288,8 @@
 
 /* --Methode-- */
-void PIBaseWdgGen::PSPrint(PSFile * psf, int ofx, int ofy)
+void PIBaseWdgGen::PSPrint(PSFile * psf, int ofx, int ofy, double scale_x, double scale_y)
 {
 if (!psf) return;
-PIGraphicPS grpsf(psf, (PIWdg *)this, ofx, ofy);
+PIGraphicPS grpsf(psf, (PIWdg *)this, ofx, ofy, scale_x, scale_y);
 Draw(&grpsf, 0, 0, XSize(), YSize());
 CallDrawers(&grpsf); 
Index: /trunk/SophyaPI/PI/pibwdggen.h
===================================================================
--- /trunk/SophyaPI/PI/pibwdggen.h	(revision 1533)
+++ /trunk/SophyaPI/PI/pibwdggen.h	(revision 1534)
@@ -73,5 +73,6 @@
 
 // PostScript output
-  virtual void       PSPrint(PSFile* psf, int ofx = 0, int ofy = 0);
+  virtual void       PSPrint(PSFile* psf, int ofx = 0, int ofy = 0,
+			     double scale_x=1., double scale_y=1.);
 
 // ------ Gestion des Drawers  ------
Index: /trunk/SophyaPI/PI/picontainergen.cc
===================================================================
--- /trunk/SophyaPI/PI/picontainergen.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/picontainergen.cc	(revision 1534)
@@ -125,10 +125,11 @@
 
 /* --Methode-- */
-void PIContainerGen::PSPrint(PSFile *psf, int ofx, int ofy)
+void PIContainerGen::PSPrint(PSFile *psf, int ofx, int ofy, double scale_x, double scale_y)
 {
 int i;
 if (!psf)  return;
 if (!Visible())  return;
-for(i=0; i<NbChilds(); i++)  GetChild(i)->PSPrint(psf, ofx+XPos(), ofy+YPos()); 
+for(i=0; i<NbChilds(); i++)  
+  GetChild(i)->PSPrint(psf, ofx+XPos(), ofy+YPos(), scale_x, scale_y); 
 return;
 }
Index: /trunk/SophyaPI/PI/picontainergen.h
===================================================================
--- /trunk/SophyaPI/PI/picontainergen.h	(revision 1533)
+++ /trunk/SophyaPI/PI/picontainergen.h	(revision 1534)
@@ -51,5 +51,6 @@
   inline  PILayoutMgr* GetLayoutMgr() { return(layout); }
 
-  virtual void         PSPrint(PSFile *psf, int ofx=0, int ofy=0);
+  virtual void         PSPrint(PSFile *psf, int ofx=0, int ofy=0,
+			       double scale_x=1., double scale_y=1.);
 
   virtual void         Show();
Index: /trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/pigraphps.cc	(revision 1534)
@@ -43,9 +43,11 @@
 
 /* --Methode-- */
-PIGraphicPS::PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx, double ofy)
+PIGraphicPS::PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx, double ofy, 
+			 double scale_x, double scale_y)
 : PIGraphicGen()
 {
 BuildFromPSFile(psf, (double)wdg->XPos()+ofx, (double)wdg->YPos()+ofy, 
-                     (double)wdg->XSize(), (double)wdg->YSize() );  
+		(double)wdg->XSize(), (double)wdg->YSize(),
+		(double)wdg->XSize()*scale_x, (double)wdg->YSize()*scale_y );  
 }
 
@@ -54,5 +56,5 @@
 : PIGraphicGen()
 {
-BuildFromPSFile(psf, x0, y0, dx, dy);
+BuildFromPSFile(psf, x0, y0, dx, dy, dx, dy);
 }
 
@@ -71,5 +73,6 @@
 
 /* --Methode-- */
-void PIGraphicPS::BuildFromPSFile(PSFile * psf, double x0, double y0, double dx, double dy)
+void PIGraphicPS::BuildFromPSFile(PSFile * psf, double x0, double y0, double tx, double ty,
+				  double dx, double dy)
 {
 mPSOut = psf;
@@ -86,5 +89,5 @@
 SelMarker(1, PI_DotMarker);
 
-if (psf) psf->NewBloc(x0, y0, dx, dy, dx, dy);
+if (psf) psf->NewBloc(x0, y0, tx, ty, dx, dy);
 mXmin = mYmin = 0.;
 mXmax = dx;  mYmax = dy;
Index: /trunk/SophyaPI/PI/pigraphps.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.h	(revision 1533)
+++ /trunk/SophyaPI/PI/pigraphps.h	(revision 1534)
@@ -9,5 +9,6 @@
 {
 public:
-                     PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx=0., double ofy=0.);
+                     PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx=0., double ofy=0.,
+				 double scale_x=1., double scale_y=1.);
                      PIGraphicPS(PSFile * psf, double x0, double y0, double dx, double dy);
   virtual           ~PIGraphicPS();
@@ -74,5 +75,6 @@
 
 protected:
-  void           BuildFromPSFile(PSFile * psf, double x0, double y0, double dx, double dy);
+  void           BuildFromPSFile(PSFile * psf, double x0, double y0, double tx, double ty,
+				 double dx, double dy);
 
   PSFile * mPSOut;  /* Fichier PostScript */
Index: /trunk/SophyaPI/PI/pistzwin.cc
===================================================================
--- /trunk/SophyaPI/PI/pistzwin.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/pistzwin.cc	(revision 1534)
@@ -172,11 +172,11 @@
 
 /* --Methode-- */
-void PIStackWindow::PSPrint(PSFile *psf, int ofx, int ofy)
+void PIStackWindow::PSPrint(PSFile *psf, int ofx, int ofy, double scale_x, double scale_y)
 {
 if (!psf) return;
 int k;
 for(k=0; k<NbChilds(); k++) { 
-  psf->NewPage((double)XSize(), (double)YSize(),PI_Auto);
-  GetChild(k)->PSPrint(psf, ofx, ofy);
+  psf->NewPage((double)XSize()*scale_x, (double)YSize()*scale_y,PI_Auto);
+  GetChild(k)->PSPrint(psf, ofx, ofy, scale_x, scale_y);
   }
 }
Index: /trunk/SophyaPI/PI/pistzwin.h
===================================================================
--- /trunk/SophyaPI/PI/pistzwin.h	(revision 1533)
+++ /trunk/SophyaPI/PI/pistzwin.h	(revision 1534)
@@ -41,5 +41,6 @@
 
   virtual void  SetLayoutMgr(PILayoutMgr* nlay);
-  virtual void  PSPrint(PSFile *psf, int ofx=0, int ofy=0);
+  virtual void  PSPrint(PSFile *psf, int ofx=0, int ofy=0,
+			double scale_x=1., double scale_y=1.);
 
   inline  void  DispNext() { ((PIStackLayout*)layout)->DispNext(); }
Index: /trunk/SophyaPI/PI/piversion.h
===================================================================
--- /trunk/SophyaPI/PI/piversion.h	(revision 1533)
+++ /trunk/SophyaPI/PI/piversion.h	(revision 1534)
@@ -2,5 +2,5 @@
 #define PIVERSION_H_SEEN
 
-#define PI_VERSIONNUMBER  2.85
+#define PI_VERSIONNUMBER  2.90
 
 #endif
Index: /trunk/SophyaPI/PI/piwdggen.cc
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/piwdggen.cc	(revision 1534)
@@ -266,12 +266,13 @@
 
 /* --Methode-- */
-void PIWdgGen::PSPrint(PSFile *psf, int ofx, int ofy)
+void PIWdgGen::PSPrint(PSFile *psf, int ofx, int ofy, double scale_x, double scale_y)
 {
 char str[256];
 
 if (!psf) return;
-psf->NewBloc((double)ofx+XPos(), (double)ofy+YPos(), (double)XSize(), (double)YSize(),
-             (double)XSize(), (double)YSize());
-psf->DrawBox(0., 0., (double)XSize(), (double)YSize());
+double dx = (double)XSize()*scale_x;
+double dy = (double)YSize()*scale_y;
+psf->NewBloc((double)ofx+XPos(), (double)ofy+YPos(), dx, dy, dx, dy);
+psf->DrawBox(0., 0., dx, dy);
 sprintf(str,"PIWdgGen::PSPrint() Kind=%ld Name= %s", kind(), Nom().c_str());
 // N.R. 07/08/99 FontName specifie dans DrawString() 
Index: /trunk/SophyaPI/PI/piwdggen.h
===================================================================
--- /trunk/SophyaPI/PI/piwdggen.h	(revision 1533)
+++ /trunk/SophyaPI/PI/piwdggen.h	(revision 1534)
@@ -100,5 +100,6 @@
   virtual bool           IfSensitive()=0;
 
-  virtual void           PSPrint(PSFile *psf, int ofx=0, int ofy=0);
+  virtual void           PSPrint(PSFile *psf, int ofx=0, int ofy=0,
+				 double scale_x=1., double scale_y=1.);
 
 //  Gestion de copier-coller
Index: /trunk/SophyaPI/PI/piwindowgen.cc
===================================================================
--- /trunk/SophyaPI/PI/piwindowgen.cc	(revision 1533)
+++ /trunk/SophyaPI/PI/piwindowgen.cc	(revision 1534)
@@ -75,11 +75,11 @@
 
 /* --Methode-- */
-void PIWindowGen::PSPrint(PSFile *psf, int ofx, int ofy)
+void PIWindowGen::PSPrint(PSFile *psf, int ofx, int ofy, double scale_x, double scale_y)
 {
 if (!psf) return;
 //int ori;
 //ori = (XSize() > YSize()) ? LANDSCAPE : PORTRAIT ;
-psf->NewPage((float)XSize(), (float)YSize(),PI_Auto);
-PIContainerGen::PSPrint(psf, ofx, ofy);
+psf->NewPage((float)XSize()*scale_x, (float)YSize()*scale_y,PI_Auto);
+PIContainerGen::PSPrint(psf, ofx, ofy, scale_x, scale_y);
 }
 
Index: /trunk/SophyaPI/PI/piwindowgen.h
===================================================================
--- /trunk/SophyaPI/PI/piwindowgen.h	(revision 1533)
+++ /trunk/SophyaPI/PI/piwindowgen.h	(revision 1534)
@@ -22,5 +22,6 @@
   virtual long      kind() {return ClassId; }
 
-  virtual void      PSPrint(PSFile *psf, int ofx=0, int ofy=0);
+  virtual void      PSPrint(PSFile *psf, int ofx=0, int ofy=0,
+			    double scale_x=1., double scale_y=1.);
 
   inline  void      AutoHideOnClose(bool ahc=true) { mAHC = ahc; }