Index: trunk/SophyaPI/PI/Tests/pit0.cc
===================================================================
--- trunk/SophyaPI/PI/Tests/pit0.cc	(revision 1534)
+++ trunk/SophyaPI/PI/Tests/pit0.cc	(revision 1538)
@@ -232,4 +232,6 @@
 
 // Gestion des actions en fonctions des messages
+      printf("DBG-PITApp::Process() Msg= %d (%d - %d) - Sender=%lx - %lx\n", 
+            (int)msg, (int)UserMsg(msg),(int)ModMsg(msg), (long)sender, (long)this);
 
 switch(UserMsg(msg))    {
Index: trunk/SophyaPI/PI/picmapview.cc
===================================================================
--- trunk/SophyaPI/PI/picmapview.cc	(revision 1534)
+++ trunk/SophyaPI/PI/picmapview.cc	(revision 1538)
@@ -122,5 +122,5 @@
       dx = (sx-xc)/(cmap->NCol()-k);
       g->SelForeground((*cmap), k);
-      g->DrawFBox(xc, 0, dx, sy);
+      g->DrawFBox(xc, 0, dx+1, sy);
       xc += dx;
     }
@@ -133,5 +133,5 @@
       yc -= dy;
       g->SelForeground((*cmap), k);
-      g->DrawFBox(0, yc, sx, dy);
+      g->DrawFBox(0, yc, sx, dy+1);
     }
   }
@@ -140,8 +140,8 @@
   if ( (cmap->Type() == CMAP_GREY32) || (cmap->Type() == CMAP_GREYINV32) ||
        (cmap->Type() == CMAP_GREY128) || (cmap->Type() == CMAP_GREYINV128) )  g->SelForeground(PI_Red);
-  else g->SelForeground(PI_Turquoise);
+  else g->SelForeground(PI_Green);
 
   if (sx > sy) {    // horizontal
-    int fsz = (sy < 20) ? sy-8 : 12;
+    int fsz = (sy < 20) ? sy-6 : 14;
     g->SelFontSzPt(fsz, PI_BoldFont);
     char buff[32];
@@ -157,5 +157,5 @@
     } 
   else {   // vertical 
-    int fsz = (sx < 40) ? sx/4 : 12;
+    int fsz = (sx < 64) ? sx/4 : 14;
     g->SelFontSzPt(fsz, PI_BoldFont);
     char buff[32];
Index: trunk/SophyaPI/PI/pigraphps.cc
===================================================================
--- trunk/SophyaPI/PI/pigraphps.cc	(revision 1534)
+++ trunk/SophyaPI/PI/pigraphps.cc	(revision 1538)
@@ -33,8 +33,9 @@
 //	"(x0, y0)" détermine l'origine du nouveau bloc rectangulaire sur 
 //	la page et "dx, dy" l'extension du bloc. 
-// PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx, double ofy)
+// PIGraphicPS(PSFile * psf, PIWdg* wdg, double ofx, double ofy, double scale_x, double scale_y)
 //	Création d'un objet "PIGraphicPS" à partir d'un objet "PSFIle* psf"
 //|	x0 = wdg->XPos()+ofx    y0 = wdg->YPos()+ofy
-//|	dx = wdg->XSize()       dy = wdg->YSize()
+//|	Extension du bloc dans la page:
+//|	Tx = wdg->XSize()*scale_x    Ty = wdg->YSize()*scale_y
 //
 // int kind()
@@ -48,6 +49,6 @@
 {
 BuildFromPSFile(psf, (double)wdg->XPos()+ofx, (double)wdg->YPos()+ofy, 
-		(double)wdg->XSize(), (double)wdg->YSize(),
-		(double)wdg->XSize()*scale_x, (double)wdg->YSize()*scale_y );  
+		(double)wdg->XSize()*scale_x, (double)wdg->YSize()*scale_y, 
+		(double)wdg->XSize(), (double)wdg->YSize());
 }
 
Index: trunk/SophyaPI/PI/psfile.cc
===================================================================
--- trunk/SophyaPI/PI/psfile.cc	(revision 1534)
+++ trunk/SophyaPI/PI/psfile.cc	(revision 1538)
@@ -472,4 +472,12 @@
 }
 
+//++
+// NewPage(double Dx, double Dy, PIOrientation orientation) 
+//	Debut de nouvelle page, (Dx,Dy) indique l'extension
+//	(taille) du systeme de coordonnees utilisees pour la page
+// EndPage()
+//	Fin de page
+//--
+
 void  PSFile::NewPage(double Dx, double Dy, PIOrientation orientation) {
 
@@ -642,4 +650,17 @@
 
 
+//++
+// NewBloc(double x0, double y0, double Tx, double Ty, double Dx, double Dy)
+//	Debut de bloc.
+//|	x0,y0 : position du bloc ds la page
+//|	Tx,Ty : Taille du bloc dans la page
+//|	Dx,Dy : Extension (taille) du systeme de coordonnees utilisateur
+//|	dans le bloc
+//
+// EndBloc()
+//	Fin de bloc
+//--
+
+
 void  PSFile::NewBloc(double x0, double y0, double Tx, double Ty,
 			      double Dx, double Dy){
@@ -857,16 +878,18 @@
 
     /* Dessin du fond */
-    if ( (FillColor != PI_NotDefColor) || (FillColor != mFillColor) )
-	mFillColor = FillColor;
-    fprintf(mPSFile, "C%d ", mFillColor) ; 
+    if ( (FillColor != PI_NotDefColor) || (FillColor != mFillColor) ) {
+      mFillColor = FillColor;
+      fprintf(mPSFile, "C%d ", mFillColor) ;
+    } 
     fprintf(mPSFile, "gs n %.2f Ux %.2f Uy %.2f Ux %.2f Uy box f gr\n",
 	    Tx, Ty, x0, y0) ; 
     
     /* Dessin du contour (s'il y a lieu) */
-    if ( (DrawColor != PI_NotDefColor) && (FillColor != DrawColor) )
+    if ( (DrawColor != PI_NotDefColor) && (FillColor != DrawColor) ) {
 	mDrawColor = DrawColor;
-    fprintf(mPSFile, "C%d ", mDrawColor) ; 
-    fprintf(mPSFile, "gs n %.2f Ux %.2f Uy %.2f Ux %.2f Uy box s gr\n",
-	    Tx, Ty, x0, y0) ;
+	fprintf(mPSFile, "C%d ", mDrawColor) ; 
+	fprintf(mPSFile, "gs n %.2f Ux %.2f Uy %.2f Ux %.2f Uy box s gr\n",
+		Tx, Ty, x0, y0) ;
+    }
 }
 
@@ -971,7 +994,8 @@
 
     /* Dessin du fond... */
-    if ( (FillColor != PI_NotDefColor) || (FillColor != mFillColor) ) 
+    if ( (FillColor != PI_NotDefColor) || (FillColor != mFillColor) ) {
 	mFillColor = FillColor;
-    fprintf(mPSFile, "C%d ", mFillColor) ;
+	fprintf(mPSFile, "C%d ", mFillColor) ;
+    }
     fprintf(mPSFile, "%.2f Ux %.2f Uy m\n", x[0], y[0]);
     int i;
@@ -981,11 +1005,12 @@
 
     /* ...puis du contour (s'il y a lieu) */
-    if ( (DrawColor != PI_NotDefColor) && (DrawColor != FillColor) )
-	mDrawColor = DrawColor;
-    fprintf(mPSFile, "C%d ", mDrawColor) ;
-    fprintf(mPSFile, "%.2f Ux %.2f Uy m\n", x[0], y[0]);
-    for(i = 1; i<n; i++) 
-      fprintf(mPSFile, cmd, x[i], y[i]);
-    fprintf(mPSFile, "c s\n");
+    if ( (DrawColor != PI_NotDefColor) && (DrawColor != FillColor) ) {
+      mDrawColor = DrawColor;
+      fprintf(mPSFile, "C%d ", mDrawColor) ;
+      fprintf(mPSFile, "%.2f Ux %.2f Uy m\n", x[0], y[0]);
+      for(i = 1; i<n; i++) 
+	fprintf(mPSFile, cmd, x[i], y[i]);
+      fprintf(mPSFile, "c s\n");
+    }
 }
 